# StructInsert

Inserts a key/value pair in to a struct - with an optional overwrite argument

## Method Signature

```
StructInsert(struct=[modifiableStruct], key=[any], value=[any], overwrite=[boolean])
```

### Arguments

| Argument    | Type               | Required | Description                                                                  | Default |
| ----------- | ------------------ | -------- | ---------------------------------------------------------------------------- | ------- |
| `struct`    | `modifiableStruct` | `true`   | The target struct                                                            |         |
| `key`       | `any`              | `true`   | The struct key                                                               |         |
| `value`     | `any`              | `true`   | The value to assign for the specified key                                    |         |
| `overwrite` | `boolean`          | `false`  | Whether to overwrite the existing value if the key exists ( default: false ) | `false` |

## Examples

### Simple Example

Inserts a new key/value into the structure

[Run Example](https://try.boxlang.io/?code=eJwli1EKgzAQBb%2BbUzz2q4InqHgAaaFnSNtFA5qG3Q0i4t2N%2BjUwzEw%2BocUKd6PBByE8QB%2F5z5HqonhhPVUvzJHc1jg1yV%2FrorLYHZNPNWgMSalQ%2BEeoGjdLMH5nS7kk1%2FDk5RX0OlAd0Q6fbSUY)

```java
map = { 
	"hair" : "brown",
	"eyes" : "green"
};
structInsert( map, "lips", "red" );
writeOutput( structKeyList( map ) );

```

Result: eyes,lips,hair

### Overwrite Example

Throws exception when you try to add a duplicate key, when allowoverwrite parameter is false.

[Run Example](https://try.boxlang.io/?code=eJwljEEOgjAQRdfMKb6zgoQTSDyAK89Q6ygkUprpNNgQ7m7F1Ute%2Fvuzi7hgAzU8ukkZZ%2FBdlzVwX5UUSYd6qUhg2gcyLdioSabZ2zUkUWsxu9jjf1Cp8qh4uncSdAPt8M78iNaFAvl0v3zVyeSWLeZas6gueuJjTF80fCtJ)

```java
map = { 
	"hair" : "brown",
	"eyes" : "green"
};
try {
	structInsert( map, "hair", "red", false );
} catch (any ex) {
	writeOutput( "error!" );
}

```

Result: error!

### Additional Examples

[Run Example](https://try.boxlang.io/?code=eJxljs0KwjAQhM%2FNUyx7qlDoXelBKkhPCj14jkmgwWQjaWIO4rvbPwvF4%2BzMfjOctOWmhwrewLL6coM9oHUOC5Zdm%2FOonKYHss%2BBlSW0nUsgoveKAvD5l52ifeZg%2BF2ZCuutiQW8uK8WBbuJ0lCvfADBA2gKbgW1wUcRZjf%2FXQvAIThw0CqXcEFMQ9YEDUKTMFGqfsRuJx2X8qRDN5VyKZX8X%2FYFW0NWfw%3D%3D)

```java
animals = { 
	COW : "moo",
	PIG : "oink"
};
// Show current animals
Dump( label="Current animals", var=animals );
// Insert cat into animals
StructInsert( animals, "cat", "meow" );
// Show animals, now includes cat
Dump( label="Animals with cat added", var=animals );

```

## Related

* [StructAppend](/boxlang-language/reference/built-in-functions/struct/structappend.md)
* [StructClear](/boxlang-language/reference/built-in-functions/struct/structclear.md)
* [StructCopy](/boxlang-language/reference/built-in-functions/struct/structcopy.md)
* [StructDelete](/boxlang-language/reference/built-in-functions/struct/structdelete.md)
* [StructEach](/boxlang-language/reference/built-in-functions/struct/structeach.md)
* [StructEquals](/boxlang-language/reference/built-in-functions/struct/structequals.md)
* [StructEvery](/boxlang-language/reference/built-in-functions/struct/structevery.md)
* [StructFilter](/boxlang-language/reference/built-in-functions/struct/structfilter.md)
* [StructFind](/boxlang-language/reference/built-in-functions/struct/structfind.md)
* [StructFindKey](/boxlang-language/reference/built-in-functions/struct/structfindkey.md)
* [StructFindValue](/boxlang-language/reference/built-in-functions/struct/structfindvalue.md)
* [StructGet](/boxlang-language/reference/built-in-functions/struct/structget.md)
* [StructGetMetadata](/boxlang-language/reference/built-in-functions/struct/structgetmetadata.md)
* [StructIsCaseSensitive](/boxlang-language/reference/built-in-functions/struct/structiscasesensitive.md)
* [StructIsOrdered](/boxlang-language/reference/built-in-functions/struct/structisordered.md)
* [StructKeyArray](/boxlang-language/reference/built-in-functions/struct/structkeyarray.md)
* [StructKeyExists](/boxlang-language/reference/built-in-functions/struct/structkeyexists.md)
* [StructKeyList](/boxlang-language/reference/built-in-functions/struct/structkeylist.md)
* [StructKeyTranslate](/boxlang-language/reference/built-in-functions/struct/structkeytranslate.md)
* [StructMap](/boxlang-language/reference/built-in-functions/struct/structmap.md)
* [StructNew](/boxlang-language/reference/built-in-functions/struct/structnew.md)
* [StructNone](/boxlang-language/reference/built-in-functions/struct/structnone.md)
* [StructReduce](/boxlang-language/reference/built-in-functions/struct/structreduce.md)
* [StructSome](/boxlang-language/reference/built-in-functions/struct/structsome.md)
* [StructSort](/boxlang-language/reference/built-in-functions/struct/structsort.md)
* [StructToQueryString](/boxlang-language/reference/built-in-functions/struct/structtoquerystring.md)
* [StructToSorted](/boxlang-language/reference/built-in-functions/struct/structtosorted.md)
* [StructUpdate](/boxlang-language/reference/built-in-functions/struct/structupdate.md)
* [StructValueArray](/boxlang-language/reference/built-in-functions/struct/structvaluearray.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/struct/structinsert.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
